~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/link-vmlinux.sh

Version: ~ [ linux-6.11.5 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.58 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.114 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.169 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.228 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.284 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.322 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.9 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/link-vmlinux.sh (Version linux-6.11.5) and /scripts/link-vmlinux.sh (Version linux-4.17.19)


  1 #!/bin/sh                                           1 #!/bin/sh
  2 # SPDX-License-Identifier: GPL-2.0                  2 # SPDX-License-Identifier: GPL-2.0
  3 #                                                   3 #
  4 # link vmlinux                                      4 # link vmlinux
  5 #                                                   5 #
  6 # vmlinux is linked from the objects in vmlinu !!   6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
  7 # vmlinux.a contains objects that are linked u !!   7 # $(KBUILD_VMLINUX_MAIN) and $(KBUILD_VMLINUX_LIBS). Most are built-in.a files
  8 # $(KBUILD_VMLINUX_LIBS) are archives which ar !!   8 # from top-level directories in the kernel tree, others are specified in
  9 # (not within --whole-archive), and do not req !!   9 # arch/$(ARCH)/Makefile. Ordering when linking is important, and
                                                   >>  10 # $(KBUILD_VMLINUX_INIT) must be first. $(KBUILD_VMLINUX_LIBS) are archives
                                                   >>  11 # which are linked conditionally (not within --whole-archive), and do not
                                                   >>  12 # require symbol indexes added.
 10 #                                                  13 #
 11 # vmlinux                                          14 # vmlinux
 12 #   ^                                              15 #   ^
 13 #   |                                              16 #   |
 14 #   +--< vmlinux.a                             !!  17 #   +-< $(KBUILD_VMLINUX_INIT)
                                                   >>  18 #   |   +--< init/version.o + more
                                                   >>  19 #   |
                                                   >>  20 #   +--< $(KBUILD_VMLINUX_MAIN)
                                                   >>  21 #   |    +--< drivers/built-in.a mm/built-in.a + more
 15 #   |                                              22 #   |
 16 #   +--< $(KBUILD_VMLINUX_LIBS)                    23 #   +--< $(KBUILD_VMLINUX_LIBS)
 17 #   |    +--< lib/lib.a + more                     24 #   |    +--< lib/lib.a + more
 18 #   |                                              25 #   |
 19 #   +-< ${kallsymso} (see description in KALLS     26 #   +-< ${kallsymso} (see description in KALLSYMS section)
 20 #                                                  27 #
 21 # vmlinux version (uname -v) cannot be updated     28 # vmlinux version (uname -v) cannot be updated during normal
 22 # descending-into-subdirs phase since we do no     29 # descending-into-subdirs phase since we do not yet know if we need to
 23 # update vmlinux.                                  30 # update vmlinux.
 24 # Therefore this step is delayed until just be     31 # Therefore this step is delayed until just before final link of vmlinux.
 25 #                                                  32 #
 26 # System.map is generated to document addresse     33 # System.map is generated to document addresses of all kernel symbols
 27                                                    34 
 28 # Error out on error                               35 # Error out on error
 29 set -e                                             36 set -e
 30                                                    37 
 31 LD="$1"                                        << 
 32 KBUILD_LDFLAGS="$2"                            << 
 33 LDFLAGS_vmlinux="$3"                           << 
 34                                                << 
 35 is_enabled() {                                 << 
 36         grep -q "^$1=y" include/config/auto.co << 
 37 }                                              << 
 38                                                << 
 39 # Nice output in kbuild format                     38 # Nice output in kbuild format
 40 # Will be supressed by "make -s"                   39 # Will be supressed by "make -s"
 41 info()                                             40 info()
 42 {                                                  41 {
 43         printf "  %-7s %s\n" "${1}" "${2}"     !!  42         if [ "${quiet}" != "silent_" ]; then
                                                   >>  43                 printf "  %-7s %s\n" ${1} ${2}
                                                   >>  44         fi
 44 }                                                  45 }
 45                                                    46 
 46 # Link of vmlinux                              !!  47 # Thin archive build here makes a final archive with symbol table and indexes
 47 # ${1} - output file                           !!  48 # from vmlinux objects INIT and MAIN, which can be used as input to linker.
 48 vmlinux_link()                                 !!  49 # KBUILD_VMLINUX_LIBS archives should already have symbol table and indexes
                                                   >>  50 # added.
                                                   >>  51 #
                                                   >>  52 # Traditional incremental style of link does not require this step
                                                   >>  53 #
                                                   >>  54 # built-in.a output file
                                                   >>  55 #
                                                   >>  56 archive_builtin()
 49 {                                                  57 {
 50         local output=${1}                      !!  58         info AR built-in.a
 51         local objs                             !!  59         rm -f built-in.a;
 52         local libs                             !!  60         ${AR} rcsTP${KBUILD_ARFLAGS} built-in.a                 \
 53         local ld                               !!  61                                 ${KBUILD_VMLINUX_INIT}          \
 54         local ldflags                          !!  62                                 ${KBUILD_VMLINUX_MAIN}
 55         local ldlibs                           !!  63 }
 56                                                << 
 57         info LD ${output}                      << 
 58                                                << 
 59         # skip output file argument            << 
 60         shift                                  << 
 61                                                << 
 62         if is_enabled CONFIG_LTO_CLANG || is_e << 
 63                 # Use vmlinux.o instead of per << 
 64                 objs=vmlinux.o                 << 
 65                 libs=                          << 
 66         else                                   << 
 67                 objs=vmlinux.a                 << 
 68                 libs="${KBUILD_VMLINUX_LIBS}"  << 
 69         fi                                     << 
 70                                                << 
 71         if is_enabled CONFIG_MODULES; then     << 
 72                 objs="${objs} .vmlinux.export. << 
 73         fi                                     << 
 74                                                << 
 75         objs="${objs} init/version-timestamp.o << 
 76                                                << 
 77         if [ "${SRCARCH}" = "um" ]; then       << 
 78                 wl=-Wl,                        << 
 79                 ld="${CC}"                     << 
 80                 ldflags="${CFLAGS_vmlinux}"    << 
 81                 ldlibs="-lutil -lrt -lpthread" << 
 82         else                                   << 
 83                 wl=                            << 
 84                 ld="${LD}"                     << 
 85                 ldflags="${KBUILD_LDFLAGS} ${L << 
 86                 ldlibs=                        << 
 87         fi                                     << 
 88                                                << 
 89         ldflags="${ldflags} ${wl}--script=${ob << 
 90                                                    64 
 91         # The kallsyms linking does not need d !!  65 # Link of vmlinux.o used for section mismatch analysis
 92         if [ -n "${strip_debug}" ] ; then      !!  66 # ${1} output file
 93                 ldflags="${ldflags} ${wl}--str !!  67 modpost_link()
 94         fi                                     !!  68 {
                                                   >>  69         local objects
 95                                                    70 
 96         if is_enabled CONFIG_VMLINUX_MAP; then !!  71         objects="--whole-archive                                \
 97                 ldflags="${ldflags} ${wl}-Map= !!  72                 built-in.a                                      \
 98         fi                                     !!  73                 --no-whole-archive                              \
                                                   >>  74                 --start-group                                   \
                                                   >>  75                 ${KBUILD_VMLINUX_LIBS}                          \
                                                   >>  76                 --end-group"
 99                                                    77 
100         ${ld} ${ldflags} -o ${output}          !!  78         ${LD} ${LDFLAGS} -r -o ${1} ${objects}
101                 ${wl}--whole-archive ${objs} $ << 
102                 ${wl}--start-group ${libs} ${w << 
103                 ${kallsymso} ${btf_vmlinux_bin << 
104 }                                                  79 }
105                                                    80 
106 # generate .BTF typeinfo from DWARF debuginfo  !!  81 # Link of vmlinux
107 # ${1} - vmlinux image                         !!  82 # ${1} - optional extra .o files
108 gen_btf()                                      !!  83 # ${2} - output file
                                                   >>  84 vmlinux_link()
109 {                                                  85 {
110         local pahole_ver                       !!  86         local lds="${objtree}/${KBUILD_LDS}"
111         local btf_data=${1}.btf.o              !!  87         local objects
112                                                    88 
113         if ! [ -x "$(command -v ${PAHOLE})" ]; !!  89         if [ "${SRCARCH}" != "um" ]; then
114                 echo >&2 "BTF: ${1}: pahole ($ !!  90                 objects="--whole-archive                        \
115                 return 1                       !!  91                         built-in.a                              \
116         fi                                     !!  92                         --no-whole-archive                      \
                                                   >>  93                         --start-group                           \
                                                   >>  94                         ${KBUILD_VMLINUX_LIBS}                  \
                                                   >>  95                         --end-group                             \
                                                   >>  96                         ${1}"
117                                                    97 
118         pahole_ver=$(${PAHOLE} --version | sed !!  98                 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}     \
119         if [ "${pahole_ver}" -lt "116" ]; then !!  99                         -T ${lds} ${objects}
120                 echo >&2 "BTF: ${1}: pahole ve << 
121                 return 1                       << 
122         fi                                     << 
123                                                << 
124         info BTF "${btf_data}"                 << 
125         LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J << 
126                                                << 
127         # Create ${btf_data} which contains ju << 
128         # SHF_ALLOC because .BTF will be part  << 
129         # deletes all symbols including __star << 
130         # be redefined in the linker script. A << 
131         # objcopy warnings: "empty loadable se << 
132         ${OBJCOPY} --only-section=.BTF --set-s << 
133                 --strip-all ${1} "${btf_data}" << 
134         # Change e_type to ET_REL so that it c << 
135         # GNU ld 2.35+ and lld do not allow an << 
136         if is_enabled CONFIG_CPU_BIG_ENDIAN; t << 
137                 et_rel='\0\1'                  << 
138         else                                      100         else
139                 et_rel='\1\0'                  !! 101                 objects="-Wl,--whole-archive                    \
                                                   >> 102                         built-in.a                              \
                                                   >> 103                         -Wl,--no-whole-archive                  \
                                                   >> 104                         -Wl,--start-group                       \
                                                   >> 105                         ${KBUILD_VMLINUX_LIBS}                  \
                                                   >> 106                         -Wl,--end-group                         \
                                                   >> 107                         ${1}"
                                                   >> 108 
                                                   >> 109                 ${CC} ${CFLAGS_vmlinux} -o ${2}                 \
                                                   >> 110                         -Wl,-T,${lds}                           \
                                                   >> 111                         ${objects}                              \
                                                   >> 112                         -lutil -lrt -lpthread
                                                   >> 113                 rm -f linux
140         fi                                        114         fi
141         printf "${et_rel}" | dd of="${btf_data << 
142                                                << 
143         btf_vmlinux_bin_o=${btf_data}          << 
144 }                                                 115 }
145                                                   116 
146 # Create ${2}.o file with all symbols from the !! 117 
                                                   >> 118 # Create ${2} .o file with all symbols from the ${1} object file
147 kallsyms()                                        119 kallsyms()
148 {                                                 120 {
                                                   >> 121         info KSYM ${2}
149         local kallsymopt;                         122         local kallsymopt;
150                                                   123 
151         if is_enabled CONFIG_KALLSYMS_ALL; the !! 124         if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
                                                   >> 125                 kallsymopt="${kallsymopt} --symbol-prefix=_"
                                                   >> 126         fi
                                                   >> 127 
                                                   >> 128         if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
152                 kallsymopt="${kallsymopt} --al    129                 kallsymopt="${kallsymopt} --all-symbols"
153         fi                                        130         fi
154                                                   131 
155         if is_enabled CONFIG_KALLSYMS_ABSOLUTE !! 132         if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
156                 kallsymopt="${kallsymopt} --ab    133                 kallsymopt="${kallsymopt} --absolute-percpu"
157         fi                                        134         fi
158                                                   135 
159         info KSYMS "${2}.S"                    !! 136         if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
160         scripts/kallsyms ${kallsymopt} "${1}"  !! 137                 kallsymopt="${kallsymopt} --base-relative"
                                                   >> 138         fi
161                                                   139 
162         info AS "${2}.o"                       !! 140         local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
163         ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE !! 141                       ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
164               ${KBUILD_AFLAGS} ${KBUILD_AFLAGS << 
165                                                   142 
166         kallsymso=${2}.o                       !! 143         local afile="`basename ${2} .o`.S"
167 }                                              << 
168                                                   144 
169 # Perform kallsyms for the given temporary vml !! 145         ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
170 sysmap_and_kallsyms()                          !! 146         ${CC} ${aflags} -c -o ${2} ${afile}
171 {                                              << 
172         mksysmap "${1}" "${1}.syms"            << 
173         kallsyms "${1}.syms" "${1}.kallsyms"   << 
174                                                << 
175         kallsyms_sysmap=${1}.syms              << 
176 }                                                 147 }
177                                                   148 
178 # Create map file with all symbols from ${1}      149 # Create map file with all symbols from ${1}
179 # See mksymap for additional details              150 # See mksymap for additional details
180 mksysmap()                                        151 mksysmap()
181 {                                                 152 {
182         info NM ${2}                           !! 153         ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
183         ${NM} -n "${1}" | sed -f "${srctree}/s << 
184 }                                                 154 }
185                                                   155 
186 sorttable()                                    !! 156 sortextable()
187 {                                                 157 {
188         ${objtree}/scripts/sorttable ${1}      !! 158         ${objtree}/scripts/sortextable ${1}
189 }                                                 159 }
190                                                   160 
                                                   >> 161 # Delete output files in case of error
191 cleanup()                                         162 cleanup()
192 {                                                 163 {
193         rm -f .btf.*                           !! 164         rm -f .tmp_System.map
                                                   >> 165         rm -f .tmp_kallsyms*
                                                   >> 166         rm -f .tmp_vmlinux*
                                                   >> 167         rm -f built-in.a
194         rm -f System.map                          168         rm -f System.map
195         rm -f vmlinux                             169         rm -f vmlinux
196         rm -f vmlinux.map                      !! 170         rm -f vmlinux.o
                                                   >> 171 }
                                                   >> 172 
                                                   >> 173 on_exit()
                                                   >> 174 {
                                                   >> 175         if [ $? -ne 0 ]; then
                                                   >> 176                 cleanup
                                                   >> 177         fi
                                                   >> 178 }
                                                   >> 179 trap on_exit EXIT
                                                   >> 180 
                                                   >> 181 on_signals()
                                                   >> 182 {
                                                   >> 183         exit 1
197 }                                                 184 }
                                                   >> 185 trap on_signals HUP INT QUIT TERM
198                                                   186 
                                                   >> 187 #
                                                   >> 188 #
199 # Use "make V=1" to debug this script             189 # Use "make V=1" to debug this script
200 case "${KBUILD_VERBOSE}" in                       190 case "${KBUILD_VERBOSE}" in
201 *1*)                                              191 *1*)
202         set -x                                    192         set -x
203         ;;                                        193         ;;
204 esac                                              194 esac
205                                                   195 
206 if [ "$1" = "clean" ]; then                       196 if [ "$1" = "clean" ]; then
207         cleanup                                   197         cleanup
208         exit 0                                    198         exit 0
209 fi                                                199 fi
210                                                   200 
211 ${MAKE} -f "${srctree}/scripts/Makefile.build" !! 201 # We need access to CONFIG_ symbols
212                                                !! 202 case "${KCONFIG_CONFIG}" in
213 btf_vmlinux_bin_o=                             !! 203 */*)
214 kallsymso=                                     !! 204         . "${KCONFIG_CONFIG}"
215 strip_debug=                                   !! 205         ;;
216                                                !! 206 *)
217 if is_enabled CONFIG_KALLSYMS; then            !! 207         # Force using a file from the current directory
218         truncate -s0 .tmp_vmlinux.kallsyms0.sy !! 208         . "./${KCONFIG_CONFIG}"
219         kallsyms .tmp_vmlinux.kallsyms0.syms . !! 209 esac
220 fi                                             << 
221                                                << 
222 if is_enabled CONFIG_KALLSYMS || is_enabled CO << 
223                                                << 
224         # The kallsyms linking does not need d << 
225         if ! is_enabled CONFIG_DEBUG_INFO_BTF; << 
226                 strip_debug=1                  << 
227         fi                                     << 
228                                                << 
229         vmlinux_link .tmp_vmlinux1             << 
230 fi                                             << 
231                                                << 
232 if is_enabled CONFIG_DEBUG_INFO_BTF; then      << 
233         if ! gen_btf .tmp_vmlinux1; then       << 
234                 echo >&2 "Failed to generate B << 
235                 echo >&2 "Try to disable CONFI << 
236                 exit 1                         << 
237         fi                                     << 
238 fi                                             << 
239                                                   210 
240 if is_enabled CONFIG_KALLSYMS; then            !! 211 # Update version
                                                   >> 212 info GEN .version
                                                   >> 213 if [ -r .version ]; then
                                                   >> 214         VERSION=$(expr 0$(cat .version) + 1)
                                                   >> 215         echo $VERSION > .version
                                                   >> 216 else
                                                   >> 217         rm -f .version
                                                   >> 218         echo 1 > .version
                                                   >> 219 fi;
                                                   >> 220 
                                                   >> 221 # final build of init/
                                                   >> 222 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
                                                   >> 223 
                                                   >> 224 archive_builtin
                                                   >> 225 
                                                   >> 226 #link vmlinux.o
                                                   >> 227 info LD vmlinux.o
                                                   >> 228 modpost_link vmlinux.o
                                                   >> 229 
                                                   >> 230 # modpost vmlinux.o to check for section mismatches
                                                   >> 231 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
                                                   >> 232 
                                                   >> 233 kallsymso=""
                                                   >> 234 kallsyms_vmlinux=""
                                                   >> 235 if [ -n "${CONFIG_KALLSYMS}" ]; then
241                                                   236 
242         # kallsyms support                        237         # kallsyms support
243         # Generate section listing all symbols    238         # Generate section listing all symbols and add it into vmlinux
244         # It's a four step process:            !! 239         # It's a three step process:
245         # 0)  Generate a dummy __kallsyms with !! 240         # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
246         # 1)  Link .tmp_vmlinux.kallsyms1 so i !! 241         #     but __kallsyms is empty.
247         #     with a dummy __kallsyms.         << 
248         #     Running kallsyms on that gives u    242         #     Running kallsyms on that gives us .tmp_kallsyms1.o with
249         #     the right size                      243         #     the right size
250         # 2)  Link .tmp_vmlinux.kallsyms2 so i !! 244         # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
251         #     the right size, but due to the a    245         #     the right size, but due to the added section, some
252         #     addresses have shifted.             246         #     addresses have shifted.
253         #     From here, we generate a correct !! 247         #     From here, we generate a correct .tmp_kallsyms2.o
254         # 3)  That link may have expanded the     248         # 3)  That link may have expanded the kernel image enough that
255         #     more linker branch stubs / tramp    249         #     more linker branch stubs / trampolines had to be added, which
256         #     introduces new names, which furt    250         #     introduces new names, which further expands kallsyms. Do another
257         #     pass if that is the case. In the    251         #     pass if that is the case. In theory it's possible this results
258         #     in even more stubs, but unlikely    252         #     in even more stubs, but unlikely.
259         #     KALLSYMS_EXTRA_PASS=1 may also u    253         #     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
260         #     other bugs.                         254         #     other bugs.
261         # 4)  The correct ${kallsymso} is link    255         # 4)  The correct ${kallsymso} is linked into the final vmlinux.
262         #                                         256         #
263         # a)  Verify that the System.map from     257         # a)  Verify that the System.map from vmlinux matches the map from
264         #     ${kallsymso}.                       258         #     ${kallsymso}.
265                                                   259 
266         # The kallsyms linking does not need d !! 260         kallsymso=.tmp_kallsyms2.o
267         strip_debug=1                          !! 261         kallsyms_vmlinux=.tmp_vmlinux2
268                                                   262 
269         sysmap_and_kallsyms .tmp_vmlinux1      !! 263         # step 1
270         size1=$(${CONFIG_SHELL} "${srctree}/sc !! 264         vmlinux_link "" .tmp_vmlinux1
271                                                !! 265         kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
272         vmlinux_link .tmp_vmlinux2             !! 266 
273         sysmap_and_kallsyms .tmp_vmlinux2      !! 267         # step 2
274         size2=$(${CONFIG_SHELL} "${srctree}/sc !! 268         vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
                                                   >> 269         kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
                                                   >> 270 
                                                   >> 271         # step 3
                                                   >> 272         size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
                                                   >> 273         size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
275                                                   274 
276         if [ $size1 -ne $size2 ] || [ -n "${KA    275         if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
277                 vmlinux_link .tmp_vmlinux3     !! 276                 kallsymso=.tmp_kallsyms3.o
278                 sysmap_and_kallsyms .tmp_vmlin !! 277                 kallsyms_vmlinux=.tmp_vmlinux3
                                                   >> 278 
                                                   >> 279                 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
                                                   >> 280 
                                                   >> 281                 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
279         fi                                        282         fi
280 fi                                                283 fi
281                                                   284 
282 strip_debug=                                   !! 285 info LD vmlinux
283                                                !! 286 vmlinux_link "${kallsymso}" vmlinux
284 vmlinux_link vmlinux                           << 
285                                                   287 
286 # fill in BTF IDs                              !! 288 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
287 if is_enabled CONFIG_DEBUG_INFO_BTF && is_enab !! 289         info SORTEX vmlinux
288         info BTFIDS vmlinux                    !! 290         sortextable vmlinux
289         ${RESOLVE_BTFIDS} vmlinux              << 
290 fi                                                291 fi
291                                                   292 
                                                   >> 293 info SYSMAP System.map
292 mksysmap vmlinux System.map                       294 mksysmap vmlinux System.map
293                                                   295 
294 if is_enabled CONFIG_BUILDTIME_TABLE_SORT; the << 
295         info SORTTAB vmlinux                   << 
296         if ! sorttable vmlinux; then           << 
297                 echo >&2 Failed to sort kernel << 
298                 exit 1                         << 
299         fi                                     << 
300 fi                                             << 
301                                                << 
302 # step a (see comment above)                      296 # step a (see comment above)
303 if is_enabled CONFIG_KALLSYMS; then            !! 297 if [ -n "${CONFIG_KALLSYMS}" ]; then
304         if ! cmp -s System.map "${kallsyms_sys !! 298         mksysmap ${kallsyms_vmlinux} .tmp_System.map
                                                   >> 299 
                                                   >> 300         if ! cmp -s System.map .tmp_System.map; then
305                 echo >&2 Inconsistent kallsyms    301                 echo >&2 Inconsistent kallsyms data
306                 echo >&2 'Try "make KALLSYMS_E !! 302                 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
307                 exit 1                            303                 exit 1
308         fi                                        304         fi
309 fi                                                305 fi
310                                                << 
311 # For fixdep                                   << 
312 echo "vmlinux: $0" > .vmlinux.d                << 
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php